import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;
import fighting.Attack;

import java.util.Random;

import commandcenter.CommandCenter;

/**
 * This class is a sample AI for Fighting ICE. RandomAI performs a random Key
 * input.
 * 
 * @author SejongStudents, Team Fighting ICE.
 *
 */
public class SejongFighter implements AIInterface {

	// Key class for return.
	Key inputKey;
	// is used for getting a random number.
	Random rnd;
	CommandCenter cc;
	FrameData fd;
	GameData gd;
	boolean p;
	Attack attack;

	// @Override
	public int initialize(GameData gameData, boolean playerNumber) {

		// initializes a Key instance.
		inputKey = new Key();
		// initializes a random instance.
		rnd = new Random();
		cc = new CommandCenter();
		gd = gameData;
		p = playerNumber;
		attack = new Attack();

		return 0;
	}

	// @Override
	public void getInformation(FrameData frameData) {
		fd = frameData;
		cc.setFrameData(frameData, p);
	}

	// @Override
	public void processing() {
		if (!fd.emptyFlag && fd.getRemainingTime() > 0) {
			if (cc.getskillFlag()) {
				inputKey = cc.getSkillKey();
			} else {
				inputKey.empty();
				cc.skillCancel();
				cc.commandCall(selectAction());
			}
		}

	}

	private String selectAction() {

		String command = "";
		String name = gd.getOpponentName(p);
		
		// If enemy character is 'LUD'
		if (name == "LUD") {

			if (cc.getDistanceX() >= 300 && cc.getMyEnergy() < 60) {
				command = "FOR_JUMP";
				if (cc.getMyCharacter().getState().name().equals("AIR")) {
					inputKey.B = true;
				}
			} else if (cc.getDistanceX() >= 300 && cc.getMyEnergy() >= 60) {
				if (cc.getEnemyCharacter().getState().name().equals("AIR")) {
					cc.commandCall("STAND_D_DF_FA");
				} else {
					cc.commandCall("STAND_D_DF_FB");
				}
			} else {
				command = "CROUCH_B";
				if (cc.getMyCharacter().isFront() == true)
					inputKey.R = true;
				else
					inputKey.L = true;

				if (cc.getMyEnergy() >= 300
						&& cc.getDistanceX() < 650
						&& !cc.getEnemyCharacter().getState().name()
								.equals("AIR")) {
					command = "STAND_D_DF_FC";
				}

				if (cc.getDistanceX() >= 64 && cc.getDistanceX() < 69) {
					cc.commandCall("CROUCH_FA");
				}
				if (cc.getDistanceX() >= 69 && cc.getDistanceX() < 300) {
					command = "FOR_JUMP";
					inputKey.B = true;
				}
			}

			return command;

		// If enemy character is 'GARNET'
		} else if (name == "GARNET") {

			if (cc.getDistanceX() >= 280 && cc.getMyEnergy() < 60) {
				command = "FOR_JUMP";
				if (cc.getMyCharacter().getState().name().equals("AIR")) {
					inputKey.B = true;
				}
			} else if (cc.getDistanceX() >= 280 && cc.getMyEnergy() >= 60) {
				if (cc.getEnemyCharacter().getState().name().equals("AIR")) {
					cc.commandCall("STAND_D_DF_FA");
				} else {
					cc.commandCall("STAND_D_DF_FB");
				}
			} else {
				command = "CROUCH_B";
				if (cc.getMyCharacter().isFront() == true)
					inputKey.R = true;
				else
					inputKey.L = true;

				if (cc.getDistanceX() >= 50 && cc.getDistanceX() < 53) {
					cc.commandCall("CROUCH_FA");
				}
				if (cc.getDistanceX() >= 53 && cc.getDistanceX() < 280) {
					command = "FOR_JUMP";
					inputKey.B = true;
				}

				if (cc.getMyEnergy() >= 300
						&& cc.getDistanceX() < 650
						&& !cc.getEnemyCharacter().getState().name()
								.equals("AIR")) {
					command = "STAND_D_DF_FC";
				}
			}

			return command;

		// If enemy character is 'ZEN'
		} else if (name == "ZEN") {

			if (cc.getDistanceX() >= 280 && cc.getMyEnergy() < 60) {
				command = "FOR_JUMP";
				if (cc.getMyCharacter().getState().name().equals("AIR")) {
					inputKey.B = true;
				}
			} else if (cc.getDistanceX() >= 280 && cc.getMyEnergy() >= 60) {
				if (cc.getEnemyCharacter().getState().name().equals("AIR")) {
					cc.commandCall("STAND_D_DF_FA");
				} else {
					cc.commandCall("STAND_D_DF_FB");
				}
			} else {
				command = "CROUCH_B";
				if (cc.getMyCharacter().isFront() == true)
					inputKey.R = true;
				else
					inputKey.L = true;

				if (cc.getDistanceX() >= 50 && cc.getDistanceX() < 53) {
					cc.commandCall("CROUCH_FA");
				}
				if (cc.getDistanceX() >= 53 && cc.getDistanceX() < 280) {
					command = "FOR_JUMP";
					inputKey.B = true;
				}

				if (cc.getMyEnergy() >= 300
						&& cc.getDistanceX() < 650
						&& !cc.getEnemyCharacter().getState().name()
								.equals("AIR")) {
					command = "STAND_D_DF_FC";
				}

			}
		} else { 
				
		}
		return command;
	}

	// @Override
	public Key input() {
		// returns Key
		return inputKey;
	}

	// @Override
	public void close() {

	}

	// @Override
	public String getCharacter() {
		return CHARACTER_GARNET;
	}
}