package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class KneeAirCounter extends Rule {

	public KneeAirCounter(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {
		return (gameState.getEnemyCharacterData().getState() == State.AIR)
				&& (gameState.getEnemyCharacterData().getState() != State.AIR)
				&& (gameState.getMyCharacterData().getState() != State.DOWN);
	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("STAND_F_D_DFB");
	}

	@Override
	public int getPriority() {
		return 2;
	}
}
