package rule;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class MegaFireballTimeExtremeLow extends Rule {

	public MegaFireballTimeExtremeLow(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {
		// remaining time < 2 seconds
		// check if myCharackter is not down or at least rising.
		// check if myHP > 0 to avoid loss of perfect win
		return (gameState.getFrameData().getRemainingTime() < 2000)
				&& (gameState.getMyCharacterData().getEnergy() >= 300)
				&& (!gameState.getMyMotionData().getMotionName()
						.equals("CHANGE_DOWN"))
				&& (!gameState.getMyMotionData().getMotionName().equals("DOWN"))
				&& (gameState.getMyCharacterData().getHp() > 0);

	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("STAND_D_DF_FC");
	}

	@Override
	public int getPriority() {
		return -6;
	}

}
