package rule;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class MegaFireballTimeLow extends Rule {

	public MegaFireballTimeLow(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		int delay = 15;
		int nowRemainingFrame = gameState.getEnemyCharacterData()
				.getRemainingFrame() - delay;
		boolean downOrRising = gameState.getEnemyMotionData().getMotionName()
				.equals("DOWN")
				|| gameState.getEnemyMotionData().getMotionName()
						.equals("RISE");

		// remaining time < 10 seconds
		return (gameState.getFrameData().getRemainingTime() < 10000)
				&& (gameState.getMyCharacterData().getEnergy() >= 300)
				&& downOrRising && (nowRemainingFrame <= 10)
				&& (ActiveComboRuleWrapper.getSingleton().rule == null);

	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("STAND_D_DF_FC");
	}

	@Override
	public int getPriority() {
		return -5;
	}

}
